=== modified file '.bzrignore'
--- .bzrignore	2010-09-30 06:24:20 +0000
+++ .bzrignore	2008-10-03 09:32:30 +0000
@@ -2,6 +2,8 @@
 *.8
 *.8mandos
 confdir
+debian/po/messages.mo
+debian/po/templates.pot
 keydir
 man
 plugin-runner
@@ -10,4 +12,3 @@
 plugins.d/password-prompt
 plugins.d/splashy
 plugins.d/usplash
-plugins.d/plymouth

=== modified file 'DBUS-API'
--- DBUS-API	2010-09-26 18:32:58 +0000
+++ DBUS-API	2010-09-12 03:00:40 +0000
@@ -76,26 +76,25 @@
    "clients.conf", in which case they are fully documented in
    mandos-clients.conf(5).
    
-   | Name                    | Type | Access     | clients.conf        |
-   |-------------------------+------+------------+---------------------|
-   | ApprovedByDefault       | b    | Read/Write | approved_by_default |
-   | ApprovalDelay (a)       | t    | Read/Write | approval_delay      |
-   | ApprovalDuration (a)    | t    | Read/Write | approval_duration   |
-   | ApprovalPending (b)     | b    | Read       | N/A                 |
-   | Checker                 | s    | Read/Write | checker             |
-   | CheckerRunning (c)      | b    | Read/Write | N/A                 |
-   | Created (d)             | s    | Read       | N/A                 |
-   | Enabled (e)             | b    | Read/Write | N/A                 |
-   | Fingerprint             | s    | Read       | fingerprint         |
-   | Host                    | s    | Read/Write | host                |
-   | Interval (a)            | t    | Read/Write | interval            |
-   | LastApprovalRequest (f) | s    | Read       | N/A                 |
-   | LastCheckedOK (g)       | s    | Read/Write | N/A                 |
-   | LastEnabled (h)         | s    | Read       | N/A                 |
-   | Name                    | s    | Read       | (Section name)      |
-   | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (i)              | ay   | Write      | secret (or secfile) |
-   | Timeout (a)             | t    | Read/Write | timeout             |
+   | Name                 | Type | Access     | clients.conf        |
+   |----------------------+------+------------+---------------------|
+   | ApprovedByDefault    | b    | Read/Write | approved_by_default |
+   | ApprovalDelay (a)    | t    | Read/Write | approval_delay      |
+   | ApprovalDuration (a) | t    | Read/Write | approval_duration   |
+   | ApprovalPending (b)  | b    | Read       | N/A                 |
+   | Checker              | s    | Read/Write | checker             |
+   | CheckerRunning (c)   | b    | Read/Write | N/A                 |
+   | Created (d)          | s    | Read       | N/A                 |
+   | Enabled (e)          | b    | Read/Write | N/A                 |
+   | Fingerprint          | s    | Read       | fingerprint         |
+   | Host                 | s    | Read/Write | host                |
+   | Interval (a)         | t    | Read/Write | interval            |
+   | LastCheckedOK (f)    | s    | Read/Write | N/A                 |
+   | LastEnabled (g)      | s    | Read       | N/A                 |
+   | Name                 | s    | Read       | (Section name)      |
+   | ObjectPath           | o    | Read       | N/A                 |
+   | Secret (h)           | ay   | Write      | secret (or secfile) |
+   | Timeout (a)          | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
    
@@ -109,20 +108,17 @@
    e) Setting this property is equivalent to calling Enable() or
       Disable().
    
-   f) The time of the last approval request, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   g) The last time a checker was successful, as a RFC 3339 string, or
+   f) The last time a checker was successful, as a RFC 3339 string, or
       an empty string if this has not happened.  Setting this property
       is equivalent to calling CheckedOK(), i.e. the current time is
       set, regardless of the string sent.  Please always use an empty
       string when setting this property, to allow for possible future
       expansion.
    
-   h) The last time this client was enabled, as a RFC 3339 string, or
+   g) The last time this client was enabled, as a RFC 3339 string, or
       an empty string if this has not happened.
    
-   i) A raw byte array, not hexadecimal digits.
+   h) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -147,26 +143,5 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
-* Copyright
-
-    Copyright © 2010 Teddy Hogeborn
-    Copyright © 2010 Björn Påhlsson
-  
-** License:
-   
-   This program is free software: you can redistribute it and/or
-   modify it under the terms of the GNU General Public License as
-   published by the Free Software Foundation, either version 3 of the
-   License, or (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful, but
-   WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see
-   <http://www.gnu.org/licenses/>.
-
 
 #+STARTUP: showall

=== modified file 'Makefile'
--- Makefile	2010-10-11 17:45:21 +0000
+++ Makefile	2010-09-23 20:14:08 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.2.3
+version=1.0.14
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2010-10-11 17:45:21 +0000
+++ NEWS	2010-09-09 18:16:14 +0000
@@ -1,46 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.2.3 (2010-10-11)
-* Server:
-** Bug fix: Expose D-Bus API also in non-debug mode.
-
-Version 1.2.2 (2010-10-07)
-* Client:
-** splashy: Minor fix to compile with non-Linux kernels.
-
-Version 1.2.1 (2010-10-02)
-* Server:
-** mandos-monitor(8): Documentation bug fix: Key for removing client
-   is "R", not "r".
-
-Version 1.2 (2010-09-28)
-* Client:
-** New "plymouth" plugin to ask for a password using the Plymouth
-   graphical boot system.
-** The Mandos client now automatically chooses a network interface if
-   the DEVICE setting in /etc/initramfs-tools/initramfs.conf is set to
-   the empty string.  This is also the new default instead of "eth0".
-** The Mandos client --connect option now loops indefinitely until a
-   password is received from the specified server.
-** Bug fix: Quote directory correctly in mandos-keygen with --password
-** Bug fix: don't use "echo -e" in mandos-keygen; unsupported by dash.
-* Server:
-** Terminology change: clients are now "ENABLED" or "DISABLED", not
-   "valid" or "invalid".
-** New D-Bus API; see the file "DBUS-API".
-** New control utilities using the new D-Bus API:
-   + mandos-ctl		       A command-line based utility
-   + mandos-monitor	       A text-based GUI interface
-** New feature: manual interactive approval or denying of clients on a
-   case-by-case basis.
-** New --debuglevel option to control logging
-** Will not write PID file if --debug is passed
-** Bug fix: Avoid race conditions with short "interval" values or
-   fast checkers.
-** Bug fix: Don't try to bind to a network interface when none is
-   specified
-
 Version 1.0.14 (2009-10-25)
 Enable building without -pie and -fPIE if BROKEN_PIE is set.
 

=== modified file 'README'
--- README	2010-09-26 18:32:58 +0000
+++ README	2009-11-03 00:12:35 +0000
@@ -144,9 +144,7 @@
   plugins to run, all competing to be the first to find a password and
   provide it to the plugin runner.
   
-  Four additional plugins are provided:
-  * plymouth(8mandos)
-    This prompts for a password when using plymouth(8).
+  Three additional plugins are provided:
   * usplash(8mandos)
     This prompts for a password when using usplash(8).
   * splashy(8mandos)
@@ -162,8 +160,8 @@
 
 * Copyright
 
-    Copyright © 2008-2010 Teddy Hogeborn
-    Copyright © 2008-2010 Björn Påhlsson
+    Copyright © 2008,2009 Teddy Hogeborn
+    Copyright © 2008,2009 Björn Påhlsson
   
 ** License:
    

=== modified file 'TODO'
--- TODO	2010-11-16 17:58:49 +0000
+++ TODO	2010-09-25 19:55:17 +0000
@@ -2,7 +2,13 @@
 
 * Use _attribute_((nonnull)) wherever possible.
 
-* mandos-applet
+* Release critical
+** mandos
+*** Do not write PID file if --debug is passed?
+    Do other programs do this?
+** Update copyright year to add 2010
+** mandos.xml
+*** Document the approval concept
 
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -105,7 +111,6 @@
 *** Properties popup
 ** Nicer crashes. Stack traces Messes up shell.
 *** Print a nice "We are sorry" message, save stack trace to log.
-** Show timeout countdown for approval
 
 * mandos-keygen
 ** TODO Loop until passwords match when run interactively

=== modified file 'common.ent'
--- common.ent	2010-10-11 17:45:21 +0000
+++ common.ent	2010-09-09 18:16:14 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.3">
+<!ENTITY version "1.0.14">

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-11 17:45:21 +0000
+++ debian/changelog	2010-09-09 18:16:14 +0000
@@ -1,61 +1,3 @@
-mandos (1.2.3-1) experimental; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Mon, 11 Oct 2010 19:37:31 +0200
-
-mandos (1.2.2-1) experimental; urgency=low
-
-  * New upstream release.
-  * plugins.d/splashy.c: Only use ELIBBAD if defined. (Closes: #599256)
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 07 Oct 2010 20:27:54 +0200
-
-mandos (1.2.1-3) experimental; urgency=low
-
-  * debian/changelog: Include entry for NMU of version 1.0.14-1.1.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 05 Oct 2010 20:58:38 +0200
-
-mandos (1.2.1-2) unstable; urgency=low
-
-  * debian/source/format: New; contains "3.0 (quilt)".  Really.
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 02 Oct 2010 19:46:59 +0200
-
-mandos (1.2.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/source/format: New; contains "3.0 (quilt)".
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 02 Oct 2010 19:03:58 +0200
-
-mandos (1.2-1) unstable; urgency=low
-
-  * New upstream release.
-  * Makefile (LINK_FORTIFY_LD): Remove "-fPIE". (Closes: #557076)
-  * debian/control: Add gnupg dependency to "mandos-client" and removed it
-    from "mandos".  Added dependency on "python-urwid" "mandos" since the
-    new "mandos-monitor" utility needs it, and on "python (>=2.6) |
-    python-multiprocessing" since the Mandos server now uses it.
-  * debian/rules: Set BROKEN_PIE on mips and mipsel if a known buggy
-    version of binutils is used.
-  * debian/mandos.docs: Also install "/usr/share/doc/mandos/DBUS-API".
-  * debian/mandos.dirs: Added "etc/dbus-1/system.d".
-  * debian/mandos-client.README.Debian: Update info about DEVICE setting
-    of initramfs.conf.
-  * debian/mandos-client.README.Debian: Remove warning about --connect not
-    looping, since it now does.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 28 Sep 2010 20:46:11 +0200
-
-mandos (1.0.14-1.1) unstable; urgency=low
-
-  * Non-maintainer upload.
-  * Rebuild against libavahi-core-dev (>= 0.6.26-1).
-
- -- Michael Biebl <biebl@debian.org>  Mon, 12 Jul 2010 16:34:34 +0200
-
 mandos (1.0.14-1) unstable; urgency=low (HIGH on mips and mipsel)
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2010-10-01 18:40:55 +0000
+++ debian/control	2010-09-09 22:26:35 +0000
@@ -7,7 +7,7 @@
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Standards-Version: 3.9.1
+Standards-Version: 3.8.3
 Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
 Homepage: http://www.fukt.bsnet.se/mandos
@@ -16,7 +16,7 @@
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.6) | python-multiprocessing
+	python-urwid
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2010-09-26 18:32:58 +0000
+++ debian/copyright	2009-01-04 21:54:55 +0000
@@ -5,8 +5,8 @@
 Upstream-Source: <http://www.fukt.bsnet.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2010 Teddy Hogeborn
-Copyright: Copyright © 2008-2010 Björn Påhlsson
+Copyright: Copyright © 2008,2009 Teddy Hogeborn
+Copyright: Copyright © 2008,2009 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2010-09-27 17:53:53 +0000
+++ debian/mandos-client.README.Debian	2009-09-08 06:28:20 +0000
@@ -1,11 +1,9 @@
 * Choose the Client Network Interface
   
-  Please make sure that the correct network interface is specified in
-  the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
-  file.  If the setting is empty, the interface will be autodetected
-  at boot time, which may not be correct.  *If* the DEVICE setting is
-  changed, it will be necessary to update the initrd image by running
-  the command
+  You MUST make sure that the correct network interface is specified
+  in the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
+  file.  *If* this is changed, it will be necessary to update the
+  initrd image by running the command
   
 	update-initramfs -k all -u
   
@@ -76,6 +74,9 @@
   instead of using ZeroConf.  The syntax for doing this is
   "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>".
   
+  Warning: this will cause the client to make exactly one attempt at
+  connecting, and then fail if it does not succeed.
+  
   For very advanced users, it it possible to specify simply
   "mandos=connect" on the kernel command line to make the system only
   set up the network (using the data in the "ip=" option) and not pass
@@ -83,4 +84,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 27 Sep 2010 19:53:21 +0200
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 08:25:58 +0200

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2010-10-13 06:12:52 +0000
+++ debian/mandos-client.lintian-overrides	2009-01-18 06:41:57 +0000
@@ -19,7 +19,6 @@
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/plymouth 4755 root/root
 
 # The directory /etc/mandos/plugins.d can be used by local system
 # administrators to place plugins in, overriding and complementing

=== removed directory 'debian/source'
=== removed file 'debian/source/format'
--- debian/source/format	2010-10-02 17:41:05 +0000
+++ debian/source/format	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-3.0 (quilt)

=== modified file 'mandos'
--- mandos	2010-10-13 17:33:08 +0000
+++ mandos	2010-09-25 19:55:17 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008,2009 Teddy Hogeborn
+# Copyright © 2008,2009 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -81,7 +81,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.2.3"
+version = "1.0.14"
 
 #logger = logging.getLogger(u'mandos')
 logger = logging.Logger(u'mandos')
@@ -204,7 +204,7 @@
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
             logger.debug(u"Zeroconf service established.")
         elif state == avahi.ENTRY_GROUP_COLLISION:
-            logger.info(u"Zeroconf service name collision.")
+            logger.warning(u"Zeroconf service name collision.")
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical(u"Avahi: Error in group state changed %s",
@@ -246,7 +246,7 @@
     checker:    subprocess.Popen(); a running checker process used
                                     to see if the client lives.
                                     'None' if no process is running.
-    checker_callback_tag: a gobject event source tag, or None
+    checker_callback_tag:  - '' -
     checker_command: string; External command which is run to check
                      if client lives.  %() expansions are done at
                      runtime with vars(self) as dict, so that for
@@ -255,13 +255,12 @@
     created:    datetime.datetime(); (UTC) object creation
     current_checker_command: string; current running checker_command
     disable_hook:  If set, called by disable() as disable_hook(self)
-    disable_initiator_tag: a gobject event source tag, or None
+    disable_initiator_tag: - '' -
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
                  uniquely identify the client
     host:       string; available for use by the checker command
     interval:   datetime.timedelta(); How often to start a new checker
-    last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
     last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
@@ -322,7 +321,6 @@
         self.host = config.get(u"host", u"")
         self.created = datetime.datetime.utcnow()
         self.enabled = False
-        self.last_approval_request = None
         self.last_enabled = None
         self.last_checked_ok = None
         self.timeout = string_to_delta(config[u"timeout"])
@@ -424,9 +422,6 @@
                                       (self.timeout_milliseconds(),
                                        self.disable))
     
-    def need_approval(self):
-        self.last_approval_request = datetime.datetime.utcnow()
-    
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         
@@ -728,11 +723,9 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = unicode(self.name).translate(
-            {ord(u"."): ord(u"_"),
-             ord(u"-"): ord(u"_")})
         self.dbus_object_path = (dbus.ObjectPath
-                                 (u"/clients/" + client_object_name))
+                                 (u"/clients/"
+                                  + self.name.replace(u".", u"_")))
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
         
@@ -820,15 +813,6 @@
                                     variant_level=1)))
         return r
     
-    def need_approval(self, *args, **kwargs):
-        r = Client.need_approval(self, *args, **kwargs)
-        # Emit D-Bus signal
-        self.PropertyChanged(
-            dbus.String(u"LastApprovalRequest"),
-            (self._datetime_to_dbus(self.last_approval_request,
-                                    variant_level=1)))
-        return r
-    
     def start_checker(self, *args, **kwargs):
         old_checker = self.checker
         if self.checker is not None:
@@ -909,15 +893,15 @@
     @dbus.service.signal(_interface, signature=u"tb")
     def NeedApproval(self, timeout, default):
         "D-Bus signal"
-        return self.need_approval()
+        pass
     
     ## Methods
-    
+
     # Approve - method
     @dbus.service.method(_interface, in_signature=u"b")
     def Approve(self, value):
         self.approve(value)
-    
+
     # CheckedOK - method
     @dbus.service.method(_interface)
     def CheckedOK(self):
@@ -1043,15 +1027,6 @@
         return dbus.String(self._datetime_to_dbus(self
                                                   .last_checked_ok))
     
-    # LastApprovalRequest - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
-    def LastApprovalRequest_dbus_property(self):
-        if self.last_approval_request is None:
-            return dbus.String(u"")
-        return dbus.String(self.
-                           _datetime_to_dbus(self
-                                             .last_approval_request))
-    
     # Timeout - property
     @dbus_service_property(_interface, signature=u"t",
                            access=u"readwrite")
@@ -1545,7 +1520,7 @@
                                u"dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address[0])
+                    mandos_dbus_service.ClientNotFound(fpr, address)
                 parent_pipe.send(False)
                 return False
             
@@ -1684,7 +1659,7 @@
     parser.add_option("--debug", action=u"store_true",
                       help=u"Debug mode; run in foreground and log to"
                       u" terminal")
-    parser.add_option("--debuglevel", type=u"string", metavar="LEVEL",
+    parser.add_option("--debuglevel", type=u"string", metavar="Level",
                       help=u"Debug level for stdout output")
     parser.add_option("--priority", type=u"string", help=u"GnuTLS"
                       u" priority string (see GnuTLS documentation)")
@@ -1788,12 +1763,11 @@
                               gnutls_priority=
                               server_settings[u"priority"],
                               use_dbus=use_dbus)
-    if not debug:
-        pidfilename = u"/var/run/mandos.pid"
-        try:
-            pidfile = open(pidfilename, u"w")
-        except IOError:
-            logger.error(u"Could not open file %r", pidfilename)
+    pidfilename = u"/var/run/mandos.pid"
+    try:
+        pidfile = open(pidfilename, u"w")
+    except IOError:
+        logger.error(u"Could not open file %r", pidfilename)
     
     try:
         uid = pwd.getpwnam(u"_mandos").pw_uid
@@ -1847,10 +1821,6 @@
         # No console logging
         logger.removeHandler(console)
     
-    # Need to fork before connecting to D-Bus
-    if not debug:
-        # Close all input and output, do double fork, etc.
-        daemon()
     
     global main_loop
     # From the Avahi example code
@@ -1874,7 +1844,11 @@
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings[u"interface"])))
-    
+
+    if not debug:
+        # Close all input and output, do double fork, etc.
+        daemon()
+        
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
     
@@ -1901,22 +1875,21 @@
     if not tcp_server.clients:
         logger.warning(u"No clients defined")
         
+    try:
+        with pidfile:
+            pid = os.getpid()
+            pidfile.write(str(pid) + "\n")
+        del pidfile
+    except IOError:
+        logger.error(u"Could not write to file %r with PID %d",
+                     pidfilename, pid)
+    except NameError:
+        # "pidfile" was never created
+        pass
+    del pidfilename
+    
     if not debug:
-        try:
-            with pidfile:
-                pid = os.getpid()
-                pidfile.write(str(pid) + "\n")
-            del pidfile
-        except IOError:
-            logger.error(u"Could not write to file %r with PID %d",
-                         pidfilename, pid)
-        except NameError:
-            # "pidfile" was never created
-            pass
-        del pidfilename
-        
         signal.signal(signal.SIGINT, signal.SIG_IGN)
-
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2010-09-27 18:57:12 +0000
+++ mandos-clients.conf.xml	2010-09-25 19:55:17 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2010-09-25">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,7 +34,6 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
-      <year>2010</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -357,28 +356,10 @@
 	<quote><literal>%%(<replaceable>foo</replaceable>)s</literal
 	></quote> will be replaced by the value of the attribute
 	<varname>foo</varname> of the internal
-	<quote><classname>Client</classname></quote> object in the
-	Mandos server.  The currently allowed values for
-	<replaceable>foo</replaceable> are:
-	<quote><literal>approval_delay</literal></quote>,
-	<quote><literal>approval_duration</literal></quote>,
-	<quote><literal>created</literal></quote>,
-	<quote><literal>enabled</literal></quote>,
-	<quote><literal>fingerprint</literal></quote>,
-	<quote><literal>host</literal></quote>,
-	<quote><literal>interval</literal></quote>,
-	<quote><literal>last_approval_request</literal></quote>,
-	<quote><literal>last_checked_ok</literal></quote>,
-	<quote><literal>last_enabled</literal></quote>,
-	<quote><literal>name</literal></quote>,
-	<quote><literal>timeout</literal></quote>, and, if using
-	D-Bus, <quote><literal>dbus_object_path</literal></quote>.
-	See the source code for details.  <emphasis role="strong"
-	>Currently, <emphasis>none</emphasis> of these attributes
-	except <quote><literal>host</literal></quote> are guaranteed
-	to be valid in future versions.</emphasis> Therefore, please
-	let the authors know of any attributes that are useful so they
-	may be preserved to any new versions of this software.
+	<quote><classname>Client</classname></quote> object.  See the
+	source code for details, and let the authors know of any
+	attributes that are useful so they may be preserved to any new
+	versions of this software.
       </para>
       <para>
 	Note that this means that, in order to include an actual

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-11 17:45:21 +0000
+++ mandos-ctl	2010-09-25 19:55:17 +0000
@@ -1,26 +1,5 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
-# Mandos Monitor - Control and monitor the Mandos server
-# 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@fukt.bsnet.se>.
-# 
 
 from __future__ import division
 import sys
@@ -38,17 +17,12 @@
     'Enabled': u'Enabled',
     'Timeout': u'Timeout',
     'LastCheckedOK': u'Last Successful Check',
-    'LastApprovalRequest': u'Last Approval Request',
     'Created': u'Created',
     'Interval': u'Interval',
     'Host': u'Host',
     'Fingerprint': u'Fingerprint',
     'CheckerRunning': u'Check Is Running',
     'LastEnabled': u'Last Enabled',
-    'ApprovalPending': u'Approval Is Pending',
-    'ApprovedByDefault': u'Approved By Default',
-    'ApprovalDelay': u"Approval Delay",
-    'ApprovalDuration': u"Approval Duration",
     'Checker': u'Checker',
     }
 defaultkeywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK')
@@ -57,7 +31,7 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+version = "1.0.14"
 
 def timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta object to milliseconds"
@@ -119,8 +93,7 @@
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
             return u"Yes" if value else u"No"
-        if keyword in (u"Timeout", u"Interval", u"ApprovalDelay",
-                       u"ApprovalDuration"):
+        if keyword in (u"Timeout", u"Interval"):
             return milliseconds_to_string(value)
         return unicode(value)
     
@@ -149,9 +122,6 @@
                 options.checker is not None,
                 options.timeout is not None,
                 options.interval is not None,
-                options.approved_by_default is not None,
-                options.approval_delay is not None,
-                options.approval_duration is not None,
                 options.host is not None,
                 options.secret is not None,
                 options.approve,
@@ -183,16 +153,6 @@
 	                  help="Set timeout for client")
 	parser.add_option("-i", "--interval", type="string",
 	                  help="Set checker interval for client")
-        parser.add_option("--approve-by-default", action="store_true",
-                          dest=u"approved_by_default",
-                          help="Set client to be approved by default")
-        parser.add_option("--deny-by-default", action="store_false",
-                          dest=u"approved_by_default",
-                          help="Set client to be denied by default")
-        parser.add_option("--approval-delay", type="string",
-                          help="Set delay before client approve/deny")
-        parser.add_option("--approval-duration", type="string",
-                          help="Set duration of one client approval")
 	parser.add_option("-H", "--host", type="string",
 	                  help="Set host for client")
 	parser.add_option("-s", "--secret", type="string",
@@ -204,13 +164,12 @@
 	options, client_names = parser.parse_args()
         
         if has_actions(options) and not client_names and not options.all:
-            parser.error('Options require clients names or --all.')
+            parser.error('Options requires clients names or --all.')
         if options.verbose and has_actions(options):
-            parser.error('--verbose can only be used alone or with'
-                         ' --all.')
+            parser.error('Verbose option can only be used alone or with --all.')
         if options.all and not has_actions(options):
-            parser.error('--all requires an action.')
-        
+            parser.error('--all requires an action')
+            
         try:
             bus = dbus.SystemBus()
             mandos_dbus_objc = bus.get_object(busname, server_path)
@@ -257,16 +216,12 @@
             
 	if not has_actions(options) and clients:
 	    if options.verbose:
-	        keywords = ('Name', 'Enabled', 'Timeout',
-                            'LastCheckedOK', 'Created', 'Interval',
-                            'Host', 'Fingerprint', 'CheckerRunning',
-                            'LastEnabled', 'ApprovalPending',
-                            'ApprovedByDefault',
-                            'LastApprovalRequest', 'ApprovalDelay',
-                            'ApprovalDuration', 'Checker')
+	        keywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK',
+	                    'Created', 'Interval', 'Host', 'Fingerprint',
+	                    'CheckerRunning', 'LastEnabled', 'Checker')
             else:
                 keywords = defaultkeywords
-            
+                
 	    print_clients(clients.values(), keywords)
         else:
             # Process each client in the list by all selected options
@@ -299,39 +254,19 @@
                                timedelta_to_milliseconds
                                (string_to_delta(options.interval)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_delay:
-                    client.Set(client_interface, u"ApprovalDelay",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_delay)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_duration:
-                    client.Set(client_interface, u"ApprovalDuration",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_duration)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.timeout:
                     client.Set(client_interface, u"Timeout",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.timeout)),
+                               timedelta_to_milliseconds(string_to_delta
+                                                         (options.timeout)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.secret:
                     client.Set(client_interface, u"Secret",
-                               dbus.ByteArray(open(options.secret,
-                                                   u'rb').read()),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approved_by_default is not None:
-                    client.Set(client_interface, u"ApprovedByDefault",
-                               dbus.Boolean(options
-                                            .approved_by_default),
+                               dbus.ByteArray(open(options.secret, u'rb').read()),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.approve:
-                    client.Approve(dbus.Boolean(True),
-                                   dbus_interface=client_interface)
-                elif options.deny:
-                    client.Approve(dbus.Boolean(False),
-                                   dbus_interface=client_interface)
+                    client.Approve(dbus.Boolean(True), dbus_interface=client_interface)
+                if options.deny:
+                    client.Approve(dbus.Boolean(False), dbus_interface=client_interface)
 
 if __name__ == '__main__':
     main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2010-09-25 23:52:17 +0000
+++ mandos-ctl.xml	2010-09-25 19:55:17 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2010-09-25">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -101,30 +101,6 @@
       </group>
       <sbr/>
       <group>
-	<arg choice="plain"><option>--approve-by-default</option
-        ></arg>
-	<sbr/>
-	<arg choice="plain"><option>--deny-by-default</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approval-delay
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approval-duration
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--interval
-	<replaceable>TIME</replaceable></option></arg>
-	<arg choice="plain"><option>-i
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
 	<arg choice="plain"><option>--host
 	<replaceable>STRING</replaceable></option></arg>
 	<arg choice="plain"><option>-H
@@ -297,8 +273,8 @@
 	  <para>
 	    Set the <varname>checker</varname> option of the specified
 	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
+	    >mandos-client.conf</refentrytitle><manvolnum>5</manvolnum
+	    ></citerefentry>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -312,8 +288,8 @@
 	  <para>
 	    Set the <varname>timeout</varname> option of the specified
 	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
+	    >mandos-client.conf</refentrytitle><manvolnum>5</manvolnum
+	    ></citerefentry>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -325,51 +301,10 @@
 	<replaceable>TIME</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Set the <varname>interval</varname> option of the
-	    specified client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--approve-by-default</option></term>
-	<term><option>--deny-by-default</option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>approved_by_default</varname> option of
-	    the specified client(s) to <literal>True</literal> or
-	    <literal>False</literal>, respectively; see
-	    <citerefentry><refentrytitle
-            >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--approval-delay
-	<replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>approval_delay</varname> option of the
-	    specified client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--approval-duration
-	<replaceable>TIME</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the <varname>approval_duration</varname> option of the
-	    specified client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
+	    Set the <varname>interval</varname> option of the specified
+	    client(s); see <citerefentry><refentrytitle
+	    >mandos-client.conf</refentrytitle><manvolnum>5</manvolnum
+	    ></citerefentry>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -383,8 +318,8 @@
 	  <para>
 	    Set the <varname>host</varname> option of the specified
 	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
+	    >mandos-client.conf</refentrytitle><manvolnum>5</manvolnum
+	    ></citerefentry>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -398,8 +333,8 @@
 	  <para>
 	    Set the <varname>secfile</varname> option of the specified
 	    client(s); see <citerefentry><refentrytitle
-	    >mandos-clients.conf</refentrytitle><manvolnum
-            >5</manvolnum></citerefentry>.
+	    >mandos-client.conf</refentrytitle><manvolnum>5</manvolnum
+	    ></citerefentry>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -536,7 +471,10 @@
 	To approve all clients currently waiting for it:
       </para>
       <para>
-	<userinput>&COMMANDNAME; --approve --all</userinput>
+
+<!-- do not wrap this line -->
+<userinput>&COMMANDNAME; --approve --all</userinput>
+
       </para>
     </informalexample>
   </refsect1>

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-11 17:45:21 +0000
+++ mandos-keygen	2010-09-13 06:19:45 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008,2009 Teddy Hogeborn
+# Copyright © 2008,2009 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.2.3"
+VERSION="1.0.14"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -195,8 +195,6 @@
 stty echo; \
 " EXIT
 
-set -e
-
 umask 077
 
 if [ "$mode" = keygen ]; then

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-02-11 19:02:24 +0000
+++ mandos-monitor	2010-09-14 18:22:03 +0000
@@ -1,28 +1,7 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
-# Mandos Monitor - Control and monitor the Mandos server
-# 
-# Copyright © 2009,2010 Teddy Hogeborn
-# Copyright © 2009,2010 Björn Påhlsson
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@fukt.bsnet.se>.
-# 
 
-from __future__ import division, absolute_import, print_function, unicode_literals
+from __future__ import division, absolute_import, with_statement
 
 import sys
 import os
@@ -42,7 +21,7 @@
 
 import locale
 
-locale.setlocale(locale.LC_ALL, '')
+locale.setlocale(locale.LC_ALL, u'')
 
 import logging
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
@@ -51,7 +30,7 @@
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+version = "1.0.15"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -65,9 +44,9 @@
     "Parse an ISO 8601 date string to a datetime.datetime()"
     if not iso:
         return None
-    d, t = iso.split("T", 1)
-    year, month, day = d.split("-", 2)
-    hour, minute, second = t.split(":", 2)
+    d, t = iso.split(u"T", 1)
+    year, month, day = d.split(u"-", 2)
+    hour, minute, second = t.split(u":", 2)
     second, fraction = divmod(float(second), 1)
     return datetime.datetime(int(year),
                              int(month),
@@ -86,7 +65,7 @@
         self.proxy = proxy_object # Mandos Client proxy object
         
         self.properties = dict()
-        self.proxy.connect_to_signal("PropertyChanged",
+        self.proxy.connect_to_signal(u"PropertyChanged",
                                      self.property_changed,
                                      client_interface,
                                      byte_arrays=True)
@@ -123,21 +102,39 @@
         self.logger = logger
         
         self._update_timer_callback_tag = None
-        self._update_timer_callback_lock = 0
         self.last_checker_failed = False
         
         # The widget shown normally
-        self._text_widget = urwid.Text("")
+        self._text_widget = urwid.Text(u"")
         # The widget shown when we have focus
-        self._focus_text_widget = urwid.Text("")
+        self._focus_text_widget = urwid.Text(u"")
         super(MandosClientWidget, self).__init__(
             update_hook=update_hook, delete_hook=delete_hook,
             *args, **kwargs)
         self.update()
         self.opened = False
-        
+        self.proxy.connect_to_signal(u"CheckerCompleted",
+                                     self.checker_completed,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"CheckerStarted",
+                                     self.checker_started,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"GotSecret",
+                                     self.got_secret,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"NeedApproval",
+                                     self.need_approval,
+                                     client_interface,
+                                     byte_arrays=True)
+        self.proxy.connect_to_signal(u"Rejected",
+                                     self.rejected,
+                                     client_interface,
+                                     byte_arrays=True)
         last_checked_ok = isoformat_to_datetime(self.properties
-                                                ["LastCheckedOK"])
+                                                [u"LastCheckedOK"])
         if last_checked_ok is None:
             self.last_checker_failed = True
         else:
@@ -146,124 +143,80 @@
                                         > datetime.timedelta
                                         (milliseconds=
                                          self.properties
-                                         ["Interval"]))
-        
+                                         [u"Interval"]))
         if self.last_checker_failed:
-            self.using_timer(True)
-        
-        if self.need_approval:
-            self.using_timer(True)
-        
-        self.proxy.connect_to_signal("CheckerCompleted",
-                                     self.checker_completed,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("CheckerStarted",
-                                     self.checker_started,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("GotSecret",
-                                     self.got_secret,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("NeedApproval",
-                                     self.need_approval,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("Rejected",
-                                     self.rejected,
-                                     client_interface,
-                                     byte_arrays=True)
-    
-    def property_changed(self, property=None, value=None):
-        super(self, MandosClientWidget).property_changed(property,
-                                                         value)
-        if property == "ApprovalPending":
-            using_timer(bool(value))
-        
-    def using_timer(self, flag):
-        """Call this method with True or False when timer should be
-        activated or deactivated.
-        """
-        old = self._update_timer_callback_lock
-        if flag:
-            self._update_timer_callback_lock += 1
-        else:
-            self._update_timer_callback_lock -= 1
-        if old == 0 and self._update_timer_callback_lock:
             self._update_timer_callback_tag = (gobject.timeout_add
                                                (1000,
                                                 self.update_timer))
-        elif old and self._update_timer_callback_lock == 0:
-            gobject.source_remove(self._update_timer_callback_tag)
-            self._update_timer_callback_tag = None
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
             if self.last_checker_failed:
                 self.last_checker_failed = False
-                self.using_timer(False)
-            #self.logger('Checker for client %s (command "%s")'
-            #            ' was successful'
-            #            % (self.properties["Name"], command))
+                gobject.source_remove(self._update_timer_callback_tag)
+                self._update_timer_callback_tag = None
+            #self.logger(u'Checker for client %s (command "%s")'
+            #            u' was successful'
+            #            % (self.properties[u"Name"], command))
             self.update()
             return
         # Checker failed
         if not self.last_checker_failed:
             self.last_checker_failed = True
-            self.using_timer(True)
+            self._update_timer_callback_tag = (gobject.timeout_add
+                                               (1000,
+                                                self.update_timer))
         if os.WIFEXITED(condition):
-            self.logger('Checker for client %s (command "%s")'
-                        ' failed with exit code %s'
-                        % (self.properties["Name"], command,
+            self.logger(u'Checker for client %s (command "%s")'
+                        u' failed with exit code %s'
+                        % (self.properties[u"Name"], command,
                            os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger('Checker for client %s (command "%s")'
-                        ' was killed by signal %s'
-                        % (self.properties["Name"], command,
+            self.logger(u'Checker for client %s (command "%s")'
+                        u' was killed by signal %s'
+                        % (self.properties[u"Name"], command,
                            os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger('Checker for client %s (command "%s")'
-                        ' dumped core'
-                        % (self.properties["Name"], command))
+            self.logger(u'Checker for client %s (command "%s")'
+                        u' dumped core'
+                        % (self.properties[u"Name"], command))
         else:
-            self.logger('Checker for client %s completed'
-                        ' mysteriously')
+            self.logger(u'Checker for client %s completed'
+                        u' mysteriously')
         self.update()
     
     def checker_started(self, command):
-        #self.logger('Client %s started checker "%s"'
-        #            % (self.properties["Name"], unicode(command)))
+        #self.logger(u'Client %s started checker "%s"'
+        #            % (self.properties[u"Name"], unicode(command)))
         pass
     
     def got_secret(self):
         self.last_checker_failed = False
-        self.logger('Client %s received its secret'
-                    % self.properties["Name"])
+        self.logger(u'Client %s received its secret'
+                    % self.properties[u"Name"])
     
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client %s needs approval within %s seconds'
+            message = u'Client %s needs approval within %s seconds'
         else:
-            message = 'Client %s will get its secret in %s seconds'
+            message = u'Client %s will get its secret in %s seconds'
         self.logger(message
-                    % (self.properties["Name"], timeout/1000))
-        self.using_timer(True)
+                    % (self.properties[u"Name"], timeout/1000))
     
     def rejected(self, reason):
-        self.logger('Client %s was rejected; reason: %s'
-                    % (self.properties["Name"], reason))
+        self.logger(u'Client %s was rejected; reason: %s'
+                    % (self.properties[u"Name"], reason))
     
     def selectable(self):
         """Make this a "selectable" widget.
         This overrides the method from urwid.FlowWidget."""
         return True
     
-    def rows(self, maxcolrow, focus=False):
+    def rows(self, (maxcol,), focus=False):
         """How many rows this widget will occupy might depend on
         whether we have focus or not.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).rows(maxcolrow, focus=focus)
+        return self.current_widget(focus).rows((maxcol,), focus=focus)
     
     def current_widget(self, focus=False):
         if focus or self.opened:
@@ -273,56 +226,45 @@
     def update(self):
         "Called when what is visible on the screen should be updated."
         # How to add standout mode to a style
-        with_standout = { "normal": "standout",
-                          "bold": "bold-standout",
-                          "underline-blink":
-                              "underline-blink-standout",
-                          "bold-underline-blink":
-                              "bold-underline-blink-standout",
+        with_standout = { u"normal": u"standout",
+                          u"bold": u"bold-standout",
+                          u"underline-blink":
+                              u"underline-blink-standout",
+                          u"bold-underline-blink":
+                              u"bold-underline-blink-standout",
                           }
 
         # Rebuild focus and non-focus widgets using current properties
 
         # Base part of a client. Name!
-        base = ('%(name)s: '
-                      % {"name": self.properties["Name"]})
-        if not self.properties["Enabled"]:
-            message = "DISABLED"
-        elif self.properties["ApprovalPending"]:
-            timeout = datetime.timedelta(milliseconds
-                                         = self.properties
-                                         ["ApprovalDelay"])
-            last_approval_request = isoformat_to_datetime(
-                self.properties["LastApprovalRequest"])
-            if last_approval_request is not None:
-                timer = timeout - (datetime.datetime.utcnow()
-                                   - last_approval_request)
-            else:
-                timer = datetime.timedelta()
-            if self.properties["ApprovedByDefault"]:
-                message = "Approval in %s. (d)eny?"
-            else:
-                message = "Denial in %s. (a)pprove?"
-            message = message % unicode(timer).rsplit(".", 1)[0]
+        base = (u'%(name)s: '
+                      % {u"name": self.properties[u"Name"]})
+        if not self.properties[u"Enabled"]:
+            message = u"DISABLED"
+        elif self.properties[u"ApprovalPending"]:
+            if self.properties[u"ApprovedByDefault"]:
+                message = u"Connection established to client. (d)eny?"
+            else:
+                message = u"Seeks approval to send secret. (a)pprove?"
         elif self.last_checker_failed:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
-                                         ["Timeout"])
+                                         [u"Timeout"])
             last_ok = isoformat_to_datetime(
-                max((self.properties["LastCheckedOK"]
-                     or self.properties["Created"]),
-                    self.properties["LastEnabled"]))
+                max((self.properties[u"LastCheckedOK"]
+                     or self.properties[u"Created"]),
+                    self.properties[u"LastEnabled"]))
             timer = timeout - (datetime.datetime.utcnow() - last_ok)
-            message = ('A checker has failed! Time until client'
-                       ' gets disabled: %s'
+            message = (u'A checker has failed! Time until client'
+                       u' gets diabled: %s'
                            % unicode(timer).rsplit(".", 1)[0])
         else:
-            message = "enabled"
+            message = u"enabled"
         self._text = "%s%s" % (base, message)
             
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
-        textlist = [("normal", self._text)]
+        textlist = [(u"normal", self._text)]
         self._text_widget.set_text(textlist)
         self._focus_text_widget.set_text([(with_standout[text[0]],
                                            text[1])
@@ -348,40 +290,40 @@
         if self.delete_hook is not None:
             self.delete_hook(self)
     
-    def render(self, maxcolrow, focus=False):
+    def render(self, (maxcol,), focus=False):
         """Render differently if we have focus.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).render(maxcolrow,
+        return self.current_widget(focus).render((maxcol,),
                                                  focus=focus)
     
-    def keypress(self, maxcolrow, key):
+    def keypress(self, (maxcol,), key):
         """Handle keys.
         This overrides the method from urwid.FlowWidget"""
-        if key == "+":
+        if key == u"+":
             self.proxy.Enable(dbus_interface = client_interface)
-        elif key == "-":
+        elif key == u"-":
             self.proxy.Disable(dbus_interface = client_interface)
-        elif key == "a":
+        elif key == u"a":
             self.proxy.Approve(dbus.Boolean(True, variant_level=1),
                                dbus_interface = client_interface)
-        elif key == "d":
+        elif key == u"d":
             self.proxy.Approve(dbus.Boolean(False, variant_level=1),
                                   dbus_interface = client_interface)
-        elif key == "R" or key == "_" or key == "ctrl k":
+        elif key == u"r" or key == u"_" or key == u"ctrl k":
             self.server_proxy_object.RemoveClient(self.proxy
                                                   .object_path)
-        elif key == "s":
+        elif key == u"s":
             self.proxy.StartChecker(dbus_interface = client_interface)
-        elif key == "S":
+        elif key == u"S":
             self.proxy.StopChecker(dbus_interface = client_interface)
-        elif key == "C":
+        elif key == u"C":
             self.proxy.CheckedOK(dbus_interface = client_interface)
         # xxx
-#         elif key == "p" or key == "=":
+#         elif key == u"p" or key == "=":
 #             self.proxy.pause()
-#         elif key == "u" or key == ":":
+#         elif key == u"u" or key == ":":
 #             self.proxy.unpause()
-#         elif key == "RET":
+#         elif key == u"RET":
 #             self.open()
         else:
             return key
@@ -403,9 +345,10 @@
     "down" key presses, thus not allowing any containing widgets to
     use them as an excuse to shift focus away from this widget.
     """
-    def keypress(self, maxcolrow, key):
-        ret = super(ConstrainedListBox, self).keypress(maxcolrow, key)
-        if ret in ("up", "down"):
+    def keypress(self, (maxcol, maxrow), key):
+        ret = super(ConstrainedListBox, self).keypress((maxcol,
+                                                        maxrow), key)
+        if ret in (u"up", u"down"):
             return
         return ret
 
@@ -420,31 +363,31 @@
         self.screen = urwid.curses_display.Screen()
         
         self.screen.register_palette((
-                ("normal",
-                 "default", "default", None),
-                ("bold",
-                 "default", "default", "bold"),
-                ("underline-blink",
-                 "default", "default", "underline"),
-                ("standout",
-                 "default", "default", "standout"),
-                ("bold-underline-blink",
-                 "default", "default", ("bold", "underline")),
-                ("bold-standout",
-                 "default", "default", ("bold", "standout")),
-                ("underline-blink-standout",
-                 "default", "default", ("underline", "standout")),
-                ("bold-underline-blink-standout",
-                 "default", "default", ("bold", "underline",
-                                          "standout")),
+                (u"normal",
+                 u"default", u"default", None),
+                (u"bold",
+                 u"default", u"default", u"bold"),
+                (u"underline-blink",
+                 u"default", u"default", u"underline"),
+                (u"standout",
+                 u"default", u"default", u"standout"),
+                (u"bold-underline-blink",
+                 u"default", u"default", (u"bold", u"underline")),
+                (u"bold-standout",
+                 u"default", u"default", (u"bold", u"standout")),
+                (u"underline-blink-standout",
+                 u"default", u"default", (u"underline", u"standout")),
+                (u"bold-underline-blink-standout",
+                 u"default", u"default", (u"bold", u"underline",
+                                          u"standout")),
                 ))
         
         if urwid.supports_unicode():
-            self.divider = "─" # \u2500
-            #self.divider = "━" # \u2501
+            self.divider = u"─" # \u2500
+            #self.divider = u"━" # \u2501
         else:
-            #self.divider = "-" # \u002d
-            self.divider = "_" # \u005f
+            #self.divider = u"-" # \u002d
+            self.divider = u"_" # \u005f
         
         self.screen.start()
         
@@ -464,19 +407,19 @@
         # This keeps track of whether self.uilist currently has
         # self.logbox in it or not
         self.log_visible = True
-        self.log_wrap = "any"
+        self.log_wrap = u"any"
         
         self.rebuild()
-        self.log_message_raw(("bold",
-                              "Mandos Monitor version " + version))
-        self.log_message_raw(("bold",
-                              "q: Quit  ?: Help"))
+        self.log_message_raw((u"bold",
+                              u"Mandos Monitor version " + version))
+        self.log_message_raw((u"bold",
+                              u"q: Quit  ?: Help"))
         
         self.busname = domain + '.Mandos'
         self.main_loop = gobject.MainLoop()
         self.bus = dbus.SystemBus()
         mandos_dbus_objc = self.bus.get_object(
-            self.busname, "/", follow_name_owner_changes=True)
+            self.busname, u"/", follow_name_owner_changes=True)
         self.mandos_serv = dbus.Interface(mandos_dbus_objc,
                                           dbus_interface
                                           = server_interface)
@@ -487,17 +430,17 @@
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
-         .connect_to_signal("ClientRemoved",
+         .connect_to_signal(u"ClientRemoved",
                             self.find_and_remove_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal("ClientAdded",
+         .connect_to_signal(u"ClientAdded",
                             self.add_new_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal("ClientNotFound",
+         .connect_to_signal(u"ClientNotFound",
                             self.client_not_found,
                             dbus_interface=server_interface,
                             byte_arrays=True))
@@ -518,8 +461,8 @@
                             path=path)
     
     def client_not_found(self, fingerprint, address):
-        self.log_message(("Client with address %s and fingerprint %s"
-                          " could not be found" % (address,
+        self.log_message((u"Client with address %s and fingerprint %s"
+                          u" could not be found" % (address,
                                                     fingerprint)))
     
     def rebuild(self):
@@ -541,7 +484,7 @@
     
     def log_message(self, message):
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw(timestamp + ": " + message)
+        self.log_message_raw(timestamp + u": " + message)
     
     def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
@@ -550,26 +493,26 @@
             and len(self.log) > self.max_log_length):
             del self.log[0:len(self.log)-self.max_log_length-1]
         self.logbox.set_focus(len(self.logbox.body.contents),
-                              coming_from="above")
+                              coming_from=u"above")
         self.refresh()
     
     def toggle_log_display(self):
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        #self.log_message("Log visibility changed to: "
+        #self.log_message(u"Log visibility changed to: "
         #                 + unicode(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
         Currently, this toggles wrapping of text lines."""
-        if self.log_wrap == "clip":
-            self.log_wrap = "any"
+        if self.log_wrap == u"clip":
+            self.log_wrap = u"any"
         else:
-            self.log_wrap = "clip"
+            self.log_wrap = u"clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        #self.log_message("Wrap mode: " + self.log_wrap)
+        #self.log_message(u"Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find an client from its object path and remove it.
@@ -602,7 +545,7 @@
         if path is None:
             path = client.proxy.object_path
         self.clients_dict[path] = client
-        self.clients.sort(None, lambda c: c.properties["Name"])
+        self.clients.sort(None, lambda c: c.properties[u"Name"])
         self.refresh()
     
     def remove_client(self, client, path=None):
@@ -639,15 +582,15 @@
     
     def process_input(self, source, condition):
         keys = self.screen.get_input()
-        translations = { "ctrl n": "down",      # Emacs
-                         "ctrl p": "up",        # Emacs
-                         "ctrl v": "page down", # Emacs
-                         "meta v": "page up",   # Emacs
-                         " ": "page down",      # less
-                         "f": "page down",      # less
-                         "b": "page up",        # less
-                         "j": "down",           # vi
-                         "k": "up",             # vi
+        translations = { u"ctrl n": u"down",      # Emacs
+                         u"ctrl p": u"up",        # Emacs
+                         u"ctrl v": u"page down", # Emacs
+                         u"meta v": u"page up",   # Emacs
+                         u" ": u"page down",      # less
+                         u"f": u"page down",      # less
+                         u"b": u"page up",        # less
+                         u"j": u"down",           # vi
+                         u"k": u"up",             # vi
                          }
         for key in keys:
             try:
@@ -655,66 +598,66 @@
             except KeyError:    # :-)
                 pass
             
-            if key == "q" or key == "Q":
+            if key == u"q" or key == u"Q":
                 self.stop()
                 break
-            elif key == "window resize":
+            elif key == u"window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "\f":  # Ctrl-L
+            elif key == u"\f":  # Ctrl-L
                 self.refresh()
-            elif key == "l" or key == "D":
+            elif key == u"l" or key == u"D":
                 self.toggle_log_display()
                 self.refresh()
-            elif key == "w" or key == "i":
+            elif key == u"w" or key == u"i":
                 self.change_log_display()
                 self.refresh()
-            elif key == "?" or key == "f1" or key == "esc":
+            elif key == u"?" or key == u"f1" or key == u"esc":
                 if not self.log_visible:
                     self.log_visible = True
                     self.rebuild()
-                self.log_message_raw(("bold",
-                                      "  ".
-                                      join(("q: Quit",
-                                            "?: Help",
-                                            "l: Log window toggle",
-                                            "TAB: Switch window",
-                                            "w: Wrap (log)"))))
-                self.log_message_raw(("bold",
-                                      "  "
-                                      .join(("Clients:",
-                                             "+: Enable",
-                                             "-: Disable",
-                                             "R: Remove",
-                                             "s: Start new checker",
-                                             "S: Stop checker",
-                                             "C: Checker OK",
-                                             "a: Approve",
-                                             "d: Deny"))))
+                self.log_message_raw((u"bold",
+                                      u"  ".
+                                      join((u"q: Quit",
+                                            u"?: Help",
+                                            u"l: Log window toggle",
+                                            u"TAB: Switch window",
+                                            u"w: Wrap (log)"))))
+                self.log_message_raw((u"bold",
+                                      u"  "
+                                      .join((u"Clients:",
+                                             u"+: Enable",
+                                             u"-: Disable",
+                                             u"r: Remove",
+                                             u"s: Start new checker",
+                                             u"S: Stop checker",
+                                             u"C: Checker OK",
+                                             u"a: Approve",
+                                             u"d: Deny"))))
                 self.refresh()
-            elif key == "tab":
+            elif key == u"tab":
                 if self.topwidget.get_focus() is self.logbox:
                     self.topwidget.set_focus(0)
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            #elif (key == "end" or key == "meta >" or key == "G"
-            #      or key == ">"):
+            #elif (key == u"end" or key == u"meta >" or key == u"G"
+            #      or key == u">"):
             #    pass            # xxx end-of-buffer
-            #elif (key == "home" or key == "meta <" or key == "g"
-            #      or key == "<"):
+            #elif (key == u"home" or key == u"meta <" or key == u"g"
+            #      or key == u"<"):
             #    pass            # xxx beginning-of-buffer
-            #elif key == "ctrl e" or key == "$":
+            #elif key == u"ctrl e" or key == u"$":
             #    pass            # xxx move-end-of-line
-            #elif key == "ctrl a" or key == "^":
+            #elif key == u"ctrl a" or key == u"^":
             #    pass            # xxx move-beginning-of-line
-            #elif key == "ctrl b" or key == "meta (" or key == "h":
+            #elif key == u"ctrl b" or key == u"meta (" or key == u"h":
             #    pass            # xxx left
-            #elif key == "ctrl f" or key == "meta )" or key == "l":
+            #elif key == u"ctrl f" or key == u"meta )" or key == u"l":
             #    pass            # xxx right
-            #elif key == "a":
+            #elif key == u"a":
             #    pass            # scroll up log
-            #elif key == "z":
+            #elif key == u"z":
             #    pass            # scroll down log
             elif self.topwidget.selectable():
                 self.topwidget.keypress(self.size, key)

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2010-09-30 06:24:20 +0000
+++ mandos-monitor.xml	2010-09-14 18:22:03 +0000
@@ -167,7 +167,7 @@
 	<entry>Deny client</entry>
       </row>
       <row>
-	<entry>R, _, Ctrl-K</entry>
+	<entry>r, _, Ctrl-K</entry>
 	<entry>Remove client</entry>
       </row>
       <row>

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-11 17:45:21 +0000
+++ mandos.lsm	2010-09-14 18:22:03 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.2.3
-Entered-date:	2010-10-11
+Version:	1.0.14
+Entered-date:	2010-09-14
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      133K mandos_1.2.3.orig.tar.gz
+	      103K mandos_1.0.14.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		133K mandos_1.2.3.orig.tar.gz
+		103K mandos_1.0.14.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-27 17:39:03 +0000
+++ mandos.xml	2010-09-12 03:00:40 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2010-09-11">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,6 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
-      <year>2010</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -87,9 +86,6 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
-      <arg><option>--debuglevel
-      <replaceable>LEVEL</replaceable></option></arg>
-      <sbr/>
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
@@ -198,24 +194,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--debuglevel
-	<replaceable>LEVEL</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Set the debugging log level.
-	    <replaceable>LEVEL</replaceable> is a string, one of
-	    <quote><literal>CRITICAL</literal></quote>,
-	    <quote><literal>ERROR</literal></quote>,
-	    <quote><literal>WARNING</literal></quote>,
-	    <quote><literal>INFO</literal></quote>, or
-	    <quote><literal>DEBUG</literal></quote>, in order of
-	    increasing verbosity.  The default level is
-	    <quote><literal>WARNING</literal></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--priority <replaceable>
 	PRIORITY</replaceable></option></term>
 	<listitem>
@@ -360,26 +338,6 @@
     </para>
   </refsect1>
   
-  <refsect1 id="approval">
-    <title>APPROVAL</title>
-    <para>
-      The server can be configured to require manual approval for a
-      client before it is sent its secret.  The delay to wait for such
-      approval and the default action (approve or deny) can be
-      configured both globally and per client; see <citerefentry>
-      <refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.  By default all clients
-      will be approved immediately without delay.
-    </para>
-    <para>
-      This can be used to deny a client its secret if not manually
-      approved within a specified time.  It can also be used to make
-      the server delay before giving a client its secret, allowing
-      optional manual denying of this specific client.
-    </para>
-    
-  </refsect1>
-  
   <refsect1 id="logging">
     <title>LOGGING</title>
     <para>
@@ -460,8 +418,8 @@
 	<term><filename>/var/run/mandos.pid</filename></term>
 	<listitem>
 	  <para>
-	    The file containing the process id of the
-	    <command>&COMMANDNAME;</command> process started last.
+	    The file containing the process id of
+	    <command>&COMMANDNAME;</command>.
 	  </para>
 	</listitem>
       </varlistentry>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2010-09-26 21:27:28 +0000
+++ plugin-runner.c	2010-09-09 22:06:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2010-09-26 18:32:58 +0000
+++ plugins.d/askpass-fifo.c	2010-09-07 16:48:58 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-26 21:27:28 +0000
+++ plugins.d/mandos-client.c	2010-09-12 18:12:11 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/mandos-client.xml	2010-08-10 19:08:24 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2009-02-09">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-11-05 18:30:07 +0000
+++ plugins.d/password-prompt.c	2010-09-07 16:48:58 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -22,23 +22,22 @@
  * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
-#define _GNU_SOURCE		/* getline(), asprintf() */
+#define _GNU_SOURCE		/* getline() */
 
 #include <termios.h> 		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO, readlink() */
+				   tcgetattr(), ECHO */
 #include <signal.h>		/* sig_atomic_t, raise(), struct
 				   sigaction, sigemptyset(),
 				   sigaction(), sigaddset(), SIGINT,
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t, struct dirent, pid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getenv(), free() */
-#include <dirent.h>		/* scandir(), alphasort() */
+				   getenv() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
 				   stdin, feof(), fputc()
 				*/
@@ -48,9 +47,7 @@
 #include <error.h>		/* error() */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <inttypes.h>		/* strtoumax() */
-#include <sys/stat.h> 		/* struct stat, lstat() */
-#include <string.h> 		/* strlen, rindex, memcmp */
+#include <string.h> 		/* strlen, rindex */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -65,10 +62,6 @@
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
-/* Needed for conflic resolution */
-const char plymouthd_path[] = "/sbin/plymouth";
-
-
 static void termination_handler(int signum){
   if(quit_now){
     return;
@@ -77,74 +70,6 @@
   signal_received = signum;
 }
 
-bool conflict_detection(void){
-
-  /* plymouth conflicts with password-promt since both want to control the
-     associated terminal. Password-prompt exit since plymouth perferms the same
-     functionallity.
-   */
-  int is_plymouth(const struct dirent *proc_entry){
-    int ret;
-    {
-      uintmax_t maxvalue;
-      char *tmp;
-      errno = 0;
-      maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
-      
-      if(errno != 0 or *tmp != '\0'
-	 or maxvalue != (uintmax_t)((pid_t)maxvalue)){
-	return 0;
-      }
-    }
-    char exe_target[sizeof(plymouthd_path)];
-    char *exe_link;
-    ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
-    if(ret == -1){
-      error(0, errno, "asprintf");
-      return 0;
-    }
-  
-    struct stat exe_stat;
-    ret = lstat(exe_link, &exe_stat);
-    if(ret == -1){
-      free(exe_link);
-      if(errno != ENOENT){
-	error(0, errno, "lstat");
-      }
-      return 0;
-    }
-  
-    if(not S_ISLNK(exe_stat.st_mode)
-       or exe_stat.st_uid != 0
-       or exe_stat.st_gid != 0){
-      free(exe_link);
-      return 0;
-    }
-  
-    ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
-    free(exe_link);
-    if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-       (memcmp(plymouthd_path, exe_target,
-	       sizeof(plymouthd_path)-1) != 0)){
-      return 0;
-    }
-    return 1;
-  }
-
-  struct dirent **direntries;
-  int ret;
-  ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-  if (ret == -1){
-    error(1, errno, "scandir");
-  }
-  if (ret < 0){
-    return 1;
-  } else {
-    return 0;
-  }
-}
-
-
 int main(int argc, char **argv){
   ssize_t sret;
   int ret;
@@ -226,14 +151,6 @@
   if(debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
-
-  if (conflict_detection()){
-    if(debug){
-      fprintf(stderr, "Stopping %s because of conflict", argv[0]);
-    }
-    return EXIT_FAILURE;
-  }
-  
   if(debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-11-16 18:10:22 +0000
+++ plugins.d/plymouth.c	2010-09-24 18:33:39 +0000
@@ -1,27 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Plymouth - Read a password from Plymouth and output it
- * 
- * Copyright © 2010 Teddy Hogeborn
- * Copyright © 2010 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
- */
-
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
 				   sigemptyset(), sigaddset(), SIGINT,
@@ -76,23 +52,21 @@
   char *prompt;
   const char *const cryptsource = getenv("cryptsource");
   const char *const crypttarget = getenv("crypttarget");
-  const char prompt_start[] = "Unlocking the disk";
-  const char prompt_end[] = "Enter passphrase";
+  const char prompt_start[] = "Enter passphrase to unlock the disk";
   
   if(cryptsource == NULL){
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s\n%s", prompt_start, prompt_end);
+      ret = asprintf(&prompt, "%s: ", prompt_start);
     } else {
-      ret = asprintf(&prompt, "%s (%s)\n%s", prompt_start,
-		     crypttarget, prompt_end);
+      ret = asprintf(&prompt, "%s (%s): ", prompt_start,
+		     crypttarget);
     }
   } else {
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s %s\n%s", prompt_start, cryptsource,
-		     prompt_end);
+      ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
     } else {
-      ret = asprintf(&prompt, "%s %s (%s)\n%s", prompt_start,
-		     cryptsource, crypttarget, prompt_end);
+      ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
+		     cryptsource, crypttarget);
     }
   }
   if(ret == -1){
@@ -144,21 +118,21 @@
 	_exit(EX_OSERR);
       }
     }
-    
+
     char **new_argv = NULL;
-    char **tmp;
+    char *tmp;
     int i = 0;
-    for (; argv[i]!=NULL; i++){
+    for (; argv[i]!=(char *)NULL; i++){
       tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
       if (tmp == NULL){
 	error(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
       }
-      new_argv = tmp;
+      new_argv = (char **)tmp;
       new_argv[i] = strdup(argv[i]);
     }
-    new_argv[i] = NULL;
+    new_argv[i] = (char *) NULL;
     
     execv(path, (char *const *)new_argv);
     error(0, errno, "execv");
@@ -198,7 +172,7 @@
       return 0;
     }
   }
-  char exe_target[sizeof(plymouthd_path)];
+  char exe_target[sizeof(plymouth_path)];
   char *exe_link;
   ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
   if(ret == -1){
@@ -225,9 +199,9 @@
   
   ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
   free(exe_link);
-  if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-      (memcmp(plymouthd_path, exe_target,
-	      sizeof(plymouthd_path)-1) != 0)){
+  if((sret != (ssize_t)sizeof(plymouth_path)-1) or
+      (memcmp(plymouth_path, exe_target,
+	      sizeof(plymouth_path)-1) != 0)){
     return 0;
   }
   return 1;
@@ -247,15 +221,7 @@
   if(maxvalue == 0){
     struct dirent **direntries;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    if (ret == -1){
-      error(0, errno, "scandir");
-    }
-    if (ret > 0){
-      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
-      if (ret < 0){
-	error(0, errno, "sscanf");
-      }
-    }
+    sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
   }
   pid_t pid;
   pid = (pid_t)maxvalue;

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.xml	2010-09-23 20:14:08 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2010-09-23">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -31,7 +31,8 @@
       </author>
     </authorgroup>
     <copyright>
-      <year>2010</year>
+      <year>2008</year>
+      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-10-07 17:46:56 +0000
+++ plugins.d/splashy.c	2010-09-07 16:48:58 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -314,9 +314,7 @@
       case ENOTDIR:
       case ELOOP:
       case EISDIR:
-#ifdef ELIBBAD
-      case ELIBBAD:		/* Linux only */
-#endif
+      case ELIBBAD:
       case EPERM:
 	_exit(EX_OSFILE);
       }

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-09-26 18:32:58 +0000
+++ plugins.d/usplash.c	2010-09-15 17:21:04 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008,2009 Teddy Hogeborn
+ * Copyright © 2008,2009 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

